// PwdChangeDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "PwdChange.h"
#include "PwdChangeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


bool SetCaption(CDialog *pDlg, int nId, UINT nResId) {
	CString strText;
	if (strText.LoadString(nResId)) {
		CWnd *pWnd = pDlg->GetDlgItem(nId);
		if (pWnd != NULL) {
			pWnd->SetWindowText(strText);
			return true;
		}
	}
	return false;
}


// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

// Implementierung
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CPwdChangeDlg-Dialogfeld

CPwdChangeDlg::CPwdChangeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPwdChangeDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPwdChangeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DOMAIN, m_Domain);
	DDX_Control(pDX, IDC_SERVER, m_Server);
	DDX_Control(pDX, IDC_USER, m_User);
	DDX_Control(pDX, IDC_OLDPASS, m_OldPass);
	DDX_Control(pDX, IDC_NEWPASS1, m_NewPass1);
	DDX_Control(pDX, IDC_NEWPASS2, m_NewPass2);
	DDX_Control(pDX, IDC_HYPERLINK, m_HyperLink);
}

BEGIN_MESSAGE_MAP(CPwdChangeDlg, CDialog)
	ON_MESSAGE(DM_GETDEFID, OnGetDefID)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
ON_BN_CLICKED(IDC_BTN_SERVER, &CPwdChangeDlg::OnBnClickedBtnServer)
ON_BN_CLICKED(IDC_BTN_USER, &CPwdChangeDlg::OnBnClickedBtnUser)
ON_BN_CLICKED(IDC_BTN_CHANGE, &CPwdChangeDlg::OnBnClickedBtnChange)
END_MESSAGE_MAP()


bool CPwdChangeDlg::SetCaption(int nId, UINT nResId) {
	return ::SetCaption(this, nId, nResId);
}


// CPwdChangeDlg-Meldungshandler

LRESULT CPwdChangeDlg::OnGetDefID(WPARAM wParam, LPARAM lParam) {
	return MAKELONG(0, DC_HASDEFID);
}

BOOL CPwdChangeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	// wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	// Hier zustzliche Initialisierung einfgen
	SetCaption(IDCANCEL, IDS_BTN_CANCEL);
	SetCaption(IDC_BTN_SERVER, IDS_BTN_SERVER);
	SetCaption(IDC_BTN_USER, IDS_BTN_USER);
	SetCaption(IDC_BTN_CHANGE, IDS_BTN_CHANGE);
	SetCaption(IDC_LBL_DOMAIN, IDS_LBL_DOMAIN);
	SetCaption(IDC_LBL_SERVER, IDS_LBL_SERVER);
	SetCaption(IDC_LBL_USER, IDS_LBL_USER);
	SetCaption(IDC_LBL_OLDPASSWORD, IDS_LBL_OLDPASSWORD);
	SetCaption(IDC_LBL_NEWPASSWORD, IDS_LBL_NEWPASSWORD);
	m_Domain.LimitText(15);
	m_Server.LimitText(15);
	m_User.LimitText(20);
	m_OldPass.LimitText(14);
	m_NewPass1.LimitText(14);
	m_NewPass2.LimitText(14);
	m_HyperLink.SetURL(_T("http://www.steffen-lange.com/"));

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CPwdChangeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wenn Sie dem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie
// den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das
// Dokument/Ansicht-Modell verwenden, wird dies automatisch ausgefhrt.

void CPwdChangeDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
// das minimierte Fenster mit der Maus zieht.
HCURSOR CPwdChangeDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CPwdChangeDlg::OnBnClickedBtnServer()
{
	// Add your control notification handler code here
	UpdateData(TRUE);
	BeginWaitCursor();

	CString domain;
	m_Domain.GetWindowText(domain);
	NetObjectEnumerator *noe = new NetServerEnumerator(domain);
	if (noe->GetError() == ERROR_SUCCESS) {
		m_Server.ResetContent();
		m_User.ResetContent();
		while (noe->HasNext()) {
			NetObject *no = noe->GetNext();
			m_Server.AddString(no->name);
		}
	}
	else {
		AfxMessageBox(NetObjectEnumerator::GetErrorMessage(noe->GetError()), MB_ICONHAND);
	}
	delete noe;

	EndWaitCursor();
	UpdateData(FALSE);
}

void CPwdChangeDlg::OnBnClickedBtnUser()
{
	// Add your control notification handler code here
	UpdateData(TRUE);
	BeginWaitCursor();

	CString server;
	m_Server.GetWindowText(server);
	NetObjectEnumerator *noe = new NetUserEnumerator(server);
	if (noe->GetError() == ERROR_SUCCESS) {
		m_User.ResetContent();
		while (noe->HasNext()) {
			NetObject *no = noe->GetNext();
			m_User.AddString(no->name);
		}
	}
	else {
		AfxMessageBox(NetObjectEnumerator::GetErrorMessage(noe->GetError()), MB_ICONHAND);
	}
	delete noe;

	EndWaitCursor();
	UpdateData(FALSE);
}

void CPwdChangeDlg::OnBnClickedBtnChange()
{
	// Add your control notification handler code here
	UpdateData(TRUE);
	BeginWaitCursor();

	CString server, user, oldpass, newpass1, newpass2;
	m_Server.GetWindowText(server);
	m_User.GetWindowText(user);
	m_OldPass.GetWindowText(oldpass);
	m_NewPass1.GetWindowText(newpass1);
	m_NewPass2.GetWindowText(newpass2);
	CString msg;
	UINT type = MB_ICONHAND;
	if ((!user.IsEmpty()) && (newpass1.Compare(newpass2) == 0)) {
		DWORD dw = ::NetUserChangePassword(server, user, oldpass, newpass1);
		msg.Format(_T("%s"), NetObjectEnumerator::GetErrorMessage(dw));
		if (dw == NERR_Success)
			type = MB_ICONASTERISK;
	}
	else {
		msg.LoadString(IDS_MSG_CHANGE);
	}
	AfxMessageBox(msg, type);

	EndWaitCursor();
	UpdateData(FALSE);
}
