// PwdChangeDlg.h : Headerdatei
//

#pragma once
#include "afxwin.h"

#include "HyperLink.h"
#include "NetInfo.h"
using namespace net;


bool SetCaption(CDialog *pDlg, int nId, UINT nResId);


// CPwdChangeDlg-Dialogfeld
class CPwdChangeDlg : public CDialog
{
// Konstruktion
public:
	CPwdChangeDlg(CWnd* pParent = NULL);	// Standardkonstruktor

// Dialogfelddaten
	enum { IDD = IDD_PWDCHANGE_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung

// Implementierung
protected:
	HICON m_hIcon;

	bool SetCaption(int nId, UINT nResId);

	// Generierte Funktionen fr die Meldungstabellen
	LRESULT OnGetDefID(WPARAM wParam, LPARAM lParam);
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
private:
	CEdit m_Domain;
	CComboBox m_Server;
	CComboBox m_User;
	CEdit m_OldPass;
	CEdit m_NewPass1;
	CEdit m_NewPass2;
	CHyperLink m_HyperLink;
	afx_msg void OnBnClickedBtnServer();
	afx_msg void OnBnClickedBtnUser();
	afx_msg void OnBnClickedBtnChange();
};
